/****************************************************************************

    CLASS:    GGsignal

    PURPOSE:  A class Setting, Unsetting and processing signals.
              Works best in a Unix enviorment.

    AUTHOR:   Gabe Garza

    CHANGES:  GBG. 07/20/1998 Initial release version

    NOTICE:   These class were written to help in the development of tools
              needed for work and home use.
              These classes were written, tested and debugged at home with
              cross-platform porting, tested and debugged at work.
              You may use freely this class to help in the development of
              tools or programs for home or work use.

*******************************************************************************/

#include "gglib.h"

#ifndef _GGsignal_
#define _GGsignal_

class GGsignal {
private:

public:
//--------------------------
  GGsignal();
//--------------------------
  int SetSignal(int iCode);
//--------------------------
  int UnSetSignal(int iCode);
//--------------------------
  virtual void ProcessSignal(int iCode) = 0;
//--------------------------
  virtual void ProcessSignalError(int iCode) = 0;
//--------------------------
};

#endif
