/****************************************************************************

    CLASS:    GGvoidP

    PURPOSE:  A class to allocated a 'void pointer' array

    AUTHOR:   Gabe Garza

    CHANGES:  GBG. 07/20/1998 Initial release version

    NOTICE:   These class were written to help in the development of tools
              needed for work and home use.
              These classes were written, tested and debugged at home with
              cross-platform porting, tested and debugged at work.
              You may use freely this class to help in the development of
              tools or programs for home or work use.

*******************************************************************************/

#include "gglib.h"

#ifndef _GGvoidP_
#define _GGvoidP_

#define P_VOIDP(A, B) (*##A)[B]

class GGvoidP : public GGmemory {

private:

  unsigned long ucNul;
  int iOffset;
  long *pPage;

//-----------------------------------
public:
//-----------------------------------
  unsigned long &operator[](int iIndex);
//-----------------------------------
  int SizeOf(void);
//-----------------------------------
};

#endif
